; ITTLE ED EADER/RITER UTILITY PACKAGE BY RAIG RUCE, 31-AN-1992
; RITTEN FOR = ACKING ET-AGAZINE; FOR -128, 1571, 1581
; PGRADED FOR -2000/4000 IGH ENSITY - DISKS, 08-AR-1994
; PGRADED TO CLEAN UP ERRORS AND ADD ABORTING, 16-AY-1996

.ORG $5400
.OBJ "@0:LRR270.BIN"

;====JUMP TABLE AND PARAMETERS INTERFACE ====

JMP INITACKAGE ;()
JMP MSIR       ;( MSEVICE, MSYPE ) : .=DIRDDR, .=DIRENTOUNT
JMP MSEAD      ;( MSEVICE, MSYPE, STARTLUSTER, LEN,.=TRANS,.=CBMFN )
JMP MSRITE     ;( MSEVICE, MSYPE, WRITEIRENT, .=TRANS, .=CBMFN )
JMP MSLUSH     ;( MSEVICE, MSYPE )
JMP MSELETE    ;( WRITEIRENT )
JMP MSORMAT    ;( MSEVICE, MSYPE, .=LOW/HIGHENSITY )
JMP MSYTESREE ;( ) : .=BYTESREE
JMP CBMOPY     ;( .=INFN, .=OUTFN, .=TR )
JMP CBMIRENT   ;( .=LFN )

.BYTE $CB,134   ;IDENTIFICATION (LOCATION PK+30)
ERRNO           .BUF 1    ;0=OK,1-15=MSDOS,16-19=INTERNAL,20-30=CBM
MSEVICE        .BUF 1
MSYPE          .BUF 1    ;$00=1571, $FF=1581 OR -2000/4000
STARTLUSTER    .BUF 2
LEN           .BUF 2    ;LENGTH MEDIUM AND LOW BYTES
WRITEIRENT     .BUF 2    ;POINTER TO DIRENT
CDIRLOCKS      .BUF 2    ;CBM DIRENT BLOCKS
CDIRYPE        .BUF 1    ;CBM DIRENT FILETYPE
CDIRLEN        .BUF 1    ;CBM DIRENT FILENAME LENGTH
CDIRAME        .BUF 16   ;CBM DIRENT FILENAME

;====GLOBAL DECLARAIONS====

KERNELISTEN = $FFB1
KERNELECOND = $FF93
KERNELNLSN  = $FFAE
KERNELCPTR  = $FFA2
KERNELIOUT  = $FFA8
KERNELPINP  = $FF47
KERNELHKIN  = $FFC6
KERNELHKOUT = $FFC9
KERNELLRCHN = $FFCC
KERNELHRIN  = $FFCF
KERNELHROUT = $FFD2
KERNELETIN  = $FFE4

ST = $90
CIALOCK = $DD00
CIALAGS = $DC0D
CIAATA  = $DC0C

CLUSTERLOCKOUNT .BUF 1        ;1 OR 2
FATLOCKS         .BUF 1        ;UP TO 9
ROOTIRLOCKS     .BUF 1        ;UP TO 14
ROOTIRNTRIES    .BUF 1        ;UP TO 224
TOTALECTORS      .BUF 2        ;UP TO 2880
FIRSTILELOCK    .BUF 1
FIRSTOOTIRLOCK .BUF 1
FILELUSTEROUNT  .BUF 2
LASTATNTRY      .BUF 2

BUFYLINDER     .BUF 1
BUFIDE         .BUF 1
FATIRTY        .BUF 1
DIRIRTY        .BUF 14  ;FLAG FOR EACH DIRECTORY BLOCK
FORMATARMS     .BUF 1
SECTORSERRACK .BYTE 9  ;DEFAULT, UP TO 18
                .BUF 4
SECTORSERYL   .BYTE 18 ;DEFAULT, UP TO 36

;====TEST ROUTINES====

MSORMAT = *
   LDA #$0E
   STA $FF00
   JSR MOUNTISK
   LDA #0  ;CYLINDER
   LDX #0  ;SIDE
   JSR READRACK
   LDA #<TRACKBUF
   LDY #>TRACKBUF
   STA 1024
   STY 1025
   RTS

;====HARDWARE LEVEL====

SEND0 = *  ;( .=BURSTOMMANDODE ) : .=ERR
   PHA
   LDA #0
   STA ST
   LDA MSEVICE
   JSR KERNELISTEN
   LDA #$6F
   JSR KERNELECOND
   LDA #"U"
   JSR KERNELIOUT
   BIT ST
   BMI SEND0RROR
   LDA #"0"
   JSR KERNELIOUT
   PLA
   JSR KERNELIOUT
   BIT ST
   BMI SEND0RROR
   CLC
   RTS

   SEND0RROR = *
   LDA #25  ;DEVICE NOT PRESENT ERROR
   STA ERRNO
   SEC
   RTS

TOGGLELOCK = *
   LDA CIALOCK
   EOR #$10
   STA CIALOCK
   RTS

SERIALAIT = *
   LDA #$08
-  BIT CIALAGS
   BEQ -
   RTS

GETURSTYTE = *
   JSR SERIALAIT
   LDX CIAATA
   JSR TOGGLELOCK
   TXA
   RTS

MOUNTISK = *  ;() : .=ERR
   LDA #%00011010
   JSR SEND0
   BCC +
   RTS
+  JSR KERNELNLSN
   BIT ST
   BMI SEND0RROR
   CLC
   JSR KERNELPINP
   BIT CIALAGS
   JSR TOGGLELOCK
   JSR GETURSTYTE
   AND #$0F
   STA ERRNO
   CMP #2
   BCS MOUNTXIT
   LDY #0
-  JSR GETURSTYTE
   STA FORMATARMS,Y
   INY
   CPY #6
   BCC -
   LDA SECTORSERRACK
   ASL
   STA SECTORSERYL
   ;** SET INTERLEAVE TO 4 IF 1571, DON'T BOTHER FOR OTHER DRIVES
   BIT MSYPE
   BMI MOUNTXIT
   LDA #%00001000
   JSR SEND0
   BCC +
   RTS
+  LDA #4
   JSR KERNELIOUT
   JSR KERNELNLSN
   CLC
   MOUNTXIT = *
   RTS

BUFPTR = 2
SECNUM = 4

READRACK = *  ;( .=CYLINDER, .=SIDE ) : TRACKBUF, .=ERR
   PHA
   TXA
   AND #$01
   ASL
   ASL
   ASL
   ASL
   BIT MSYPE
   BPL +
   EOR #$10
+  JSR SEND0
   PLA
   BCC +
   RTS
+  JSR KERNELIOUT      ;CYLINDER NUMBER
   LDA #1               ;START SECTOR NUMBER
   JSR KERNELIOUT
   LDA SECTORSERRACK  ;SECTOR COUNT
   JSR KERNELIOUT
   JSR KERNELNLSN
   SEI
   CLC
   JSR KERNELPINP
   BIT CIALAGS
   JSR TOGGLELOCK
   LDA #<TRACKBUF
   LDY #>TRACKBUF
   STA BUFPTR+0
   STY BUFPTR+1
   LDA #0
   STA SECNUM
-  BIT MSYPE
   BMI +
   JSR GET1571UFTR
+  JSR READECTOR
   BCS TRACKXIT
   INC SECNUM
   LDA SECNUM
   CMP SECTORSERRACK
   BCC -
   JSR TOGGLELOCK
   CLC
   TRACKXIT = *
   CLI
   RTS

GET1571UFTR = *
   LDA #<TRACKBUF
   STA BUFPTR
   LDX SECNUM
   CLC
   LDA #>TRACKBUF
   ADC BUFPTR1571,X
   STA BUFPTR+1
   RTS

BUFPTR1571 = *
   .BYTE 0,8,16,6,14,4,12,2,10

READECTOR = *  ;( BUFPTR ) : .=ERR
   JSR GETURSTYTE
   AND #$0F
   STA ERRNO
   CMP #2
   BCC +
   RTS
+  LDX #2
   LDY #0

   READYTE = *
   LDA #$08
-  BIT CIALAGS
   BEQ -
   LDA CIALOCK
   EOR #$10
   STA CIALOCK
   LDA CIAATA
   STA (BUFPTR),Y
   INY
   BNE READYTE
   INC BUFPTR+1
   DEX
   BNE READYTE
   CLC
   RTS

OLDLOCK = 5

WRITEECTOR = *  ;( BUFPTR, .=CYLINDER, .=SIDE, .=SECTOR ) : .=ERR
   PHA
   STY SECNUM
   TXA
   AND #$01
   ASL
   ASL
   ASL
   ASL
   ORA #$02
   BIT MSYPE
   BPL +
   EOR #$10
+  JSR SEND0
   PLA
   BCC +
   RTS
+  JSR KERNELIOUT      ;TRACK NUMBER
   LDA SECNUM           ;SECTOR NUMBER
   JSR KERNELIOUT
   LDA #1               ;SECTOR COUNT
   JSR KERNELIOUT
   JSR KERNELNLSN
   SEI
   LDA #$40
   STA OLDLOCK
   SEC
   JSR KERNELPINP      ;SET FOR BURST OUTPUT
   SEI
   BIT CIALAGS
   LDX #2
   LDY #0

   WRITEYTE = *
   LDA CIALOCK
   CMP CIALOCK
   BNE WRITEYTE
   EOR OLDLOCK
   AND #$40
   BEQ WRITEYTE
   LDA (BUFPTR),Y
   STA CIAATA
   LDA OLDLOCK
   EOR #$40
   STA OLDLOCK
   LDA #8
-  BIT CIALAGS
   BEQ -
   INY
   BNE WRITEYTE
   INC BUFPTR+1
   DEX
   BNE WRITEYTE

   CLC
   JSR KERNELPINP
   BIT CIALAGS
   JSR TOGGLELOCK
   JSR SERIALAIT
   LDX CIAATA
   JSR TOGGLELOCK
   TXA
   AND #$0F
   STA ERRNO
   CMP #2
   CLI
   RTS

;====LOGICAL-SECTOR LEVEL====

INITACKAGE = *
   LDA #$0E
   STA $FF00
   LDA #$FF
   STA BUFYLINDER
   STA BUFIDE
   LDX #13
-  STA DIRIRTY,X
   DEX
   BPL -
   STA FATIRTY
   CLC
   RTS

SECTORAVE = 5

READLOCK = *  ;( .=CYLINDER,.=SIDE,.=SECTOR ) : .=BLKTR,.=ERR
   CMP BUFYLINDER
   BNE READLOCKHYSICAL
   CPX BUFIDE
   BNE READLOCKHYSICAL
   DEY
   TYA
   ASL
   CLC
   ADC #>TRACKBUF
   TAY
   LDA #<TRACKBUF
   CLC
   RTS

   READLOCKHYSICAL = *
   STA BUFYLINDER
   STX BUFIDE
   STY SECTORAVE
   JSR READRACK
   BCC READLOCKHYSICALK
   LDA ERRNO
   AND #$0F
   CMP #11    ;DISK CHANGE
   BEQ +
-  LDA #$FF
   STA BUFYLINDER
   STX BUFIDE
   SEC
   RTS
+  JSR MOUNTISK
   LDA BUFYLINDER
   LDX BUFIDE
   LDY SECTORAVE
   BCC READLOCKHYSICAL
   JMP -

   READLOCKHYSICALK = *
   LDA BUFYLINDER
   LDX BUFIDE
   LDY SECTORAVE
   JMP READLOCK

DIVIDEYYLECS = *  ;( .=NUMBER ) : .=QUOTIENT, .=REMAINDER
   LDX #$FF
-  INX
   SEC
   SBC SECTORSERYL
   BCS -
   DEY
   BPL -
   CLC
   ADC SECTORSERYL
   INY
   TAY
   TXA
   RTS

CONVERTOGICALLOCKUM = *  ;( .=BLOCKUM ) : .=CYL, .=SIDE, .=SEC
   JSR DIVIDEYYLECS
   LDX #0
   CPY SECTORSERRACK
   BCC +
   PHA
   TYA
   SBC SECTORSERRACK
   TAY
   PLA
   LDX #1
+  INY
   RTS

DESTTR = 6
CURYLINDER = 8
CURIDE = 9
CURECTOR = 10
BLOCKOUNTDOWN = 11
SOURCETR = 12

COPYLOCKS = *  ;( .=STARTLOCK, .=BLOCKOUNT, ($6)=DEST ) : .=ERR
   STX BLOCKOUNTDOWN
   JSR CONVERTOGICALLOCKUM
   STA CURYLINDER
   STX CURIDE
   STY CURECTOR

   COPYLOCKOOP = *
   LDA CURYLINDER
   LDX CURIDE
   LDY CURECTOR
   JSR READLOCK
   BCC +
   RTS
+  STA SOURCETR+0
   STY SOURCETR+1
   LDX #2
   LDY #0
-  LDA (SOURCETR),Y
   STA (DESTTR),Y
   INY
   LDA (SOURCETR),Y
   STA (DESTTR),Y
   INY
   BNE -
   INC SOURCETR+1
   INC DESTTR+1
   DEX
   BNE -
   INC CURECTOR
   LDA CURECTOR
   CMP SECTORSERRACK
   BEQ +
   BCC +
   LDA #1
   STA CURECTOR
   INC CURIDE
   LDA CURIDE
   CMP #2
   BCC +
   LDA #0
   STA CURIDE
   INC CURYLINDER
+  DEC BLOCKOUNTDOWN
   BNE COPYLOCKOOP
   CLC
   RTS

CONVERTLUSTERUM = *  ;( .=CLUSTERUM ) : .=LOGICALLOCKUM
   SEC
   SBC #2
   BCS +
   DEY
+  LDX CLUSTERLOCKOUNT
   CPX #1
   BEQ +
   ASL
   STY 7
   ROL 7
   LDY 7
+  CLC
   ADC FIRSTILELOCK
   BCC +
   INY
+  RTS

READLUSTER = *  ;( .=CLUSTERUMBER ) : CLUSTERUF, .=ERR
   JSR CONVERTLUSTERUM

   ;** READ LOGICAL BLOCKS COMPRISING CLUSTER
   LDX #<CLUSTERUF
   STX 6
   LDX #>CLUSTERUF
   STX 7
   LDX CLUSTERLOCKOUNT
   JMP COPYLOCKS

WRITEOGICALLOCK = *  ;( .=LOGICALLOCKUMBER, BUFPTR ) : .=ERR
   JSR CONVERTOGICALLOCKUM
   CMP BUFYLINDER
   BNE +
   CPX BUFIDE
   BNE +
   PHA
   LDA #$FF
   STA BUFYLINDER
   STA BUFIDE
   PLA
+  JSR WRITEECTOR
   RTS

WRITELUSTERAVE .BUF 2

WRITELUSTER = *  ;( .=CLUSTERUMBER, CLUSTERUF ) : .=ERR
   JSR CONVERTLUSTERUM
   LDX #<CLUSTERUF
   STX BUFPTR+0
   LDX #>CLUSTERUF
   STX BUFPTR+1
   STA WRITELUSTERAVE+0
   STY WRITELUSTERAVE+1
   JSR WRITEOGICALLOCK
   BCC +
   RTS
+  LDA CLUSTERLOCKOUNT
   CMP #2
   BCS +
   RTS
+  LDA WRITELUSTERAVE+0
   LDY WRITELUSTERAVE+1
   CLC
   ADC #1
   BCC +
   INY
+  JSR WRITEOGICALLOCK
   RTS

;====- FORMAT LEVEL====

BOOTLOCK = 2

MSIR = *  ;( .=FORCEOUNT ) : .=DIRBUF, .=DIRNTRIES, .=ERR
   LDX #$0E
   STX $FF00

   CMP #$D0
   BNE +
   JSR MOUNTISK
   BCC +
   RTS

   ;** GET PARAMETERS FROM BOOT SECTOR
+  LDA #0
   LDY #0
   JSR CONVERTOGICALLOCKUM
   JSR READLOCK
   BCC +
   RTS
+  STA BOOTLOCK+0
   STY BOOTLOCK+1
   LDY #13              ;GET CLUSTER SIZE
   LDA (BOOTLOCK),Y
   STA CLUSTERLOCKOUNT
   CMP #3
   BCC +

   INVALIDARMS = *
   LDA #17  ;INVALID DISK PARMS ERROR
   STA ERRNO
   SEC
   RTS

+  LDY #16              ;CHECK  REPLICATION COUNT, MUST BE 2
   LDA (BOOTLOCK),Y
   CMP #2
   BNE INVALIDARMS
   LDY #22              ;GET  SIZE IN SECTORS, MAX OF 9
   LDA (BOOTLOCK),Y
   STA FATLOCKS
   CMP #10
   BCS INVALIDARMS
   LDY #17              ;GET DIRECTORY SIZE
   LDA (BOOTLOCK),Y
   STA ROOTIRNTRIES
   CMP #225
   BCS INVALIDARMS
   LSR
   LSR
   LSR
   LSR
   STA ROOTIRLOCKS
   LDY #19              ;GET TOTAL SECTOR COUNT
   LDA (BOOTLOCK),Y
   STA TOTALECTORS+0
   INY
   LDA (BOOTLOCK),Y
   STA TOTALECTORS+1
   LDY #24              ;CHECK SECTORS PER TRACK, MUST BE 18 OR FEWER
   LDA (BOOTLOCK),Y
   CMP #19
   BCS INVALIDARMS
   LDY #26
   LDA (BOOTLOCK),Y
   CMP #2               ;CHECK NUMBER OF SIDES, MUST BE 2
   BNE INVALIDARMS
   LDY #14              ;CHECK NUMBER OF BOOT SECTORS, MUST BE 1
   LDA (BOOTLOCK),Y
   CMP #1
   BNE INVALIDARMS

   ;** GET DERIVED PARAMETERS
   LDA FATLOCKS        ;FIRST ROOT DIRECTORY SECTOR
   ASL
   CLC
   ADC #1
   STA FIRSTOOTIRLOCK
   CLC                  ;FIRST FILE SECTOR
   ADC ROOTIRLOCKS
   STA FIRSTILELOCK
   LDA TOTALECTORS+0   ;NUMBER OF FILE CLUSTERS
   LDY TOTALECTORS+1
   SEC
   SBC FIRSTILELOCK
   BCS +
   DEY
+  STA FILELUSTEROUNT+0
   STY FILELUSTEROUNT+1
   LDA CLUSTERLOCKOUNT
   CMP #2
   BNE +
   LSR FILELUSTEROUNT+1
   ROR FILELUSTEROUNT+0
+  CLC
   LDA FILELUSTEROUNT+0
   ADC #2
   STA LASTATNTRY+0
   LDA FILELUSTEROUNT+1
   ADC #0
   STA LASTATNTRY+1

   ;** LOAD 
   LDA #<FATBUF
   LDY #>FATBUF
   STA 6
   STY 7
   LDA #1
   LDY #0
   LDX FATLOCKS
   JSR COPYLOCKS
   BCC +
   RTS

   ;** LOAD ACTUAL DIRECTORY
+  LDA #<DIRBUF
   LDY #>DIRBUF
   STA 6
   STY 7
   LDA FIRSTOOTIRLOCK
   LDY #0
   LDX ROOTIRLOCKS
   JSR COPYLOCKS
   BCC +
   RTS
+  LDA #<DIRBUF
   LDY #>DIRBUF
   LDX ROOTIRNTRIES
   CLC
   RTS

ENTRYDDR = 2
ENTRYORK = 4
ENTRYITS = 5
ENTRYATA0 = 6
ENTRYATA1 = 7
ENTRYATA2 = 8

LOCATEATNTRY = *  ;( .=FATNTRYUMBER ) : ENTRYDDR, ENTRYITS1
   STA ENTRYITS
   ;** DIVIDE BY TWO
   STY ENTRYDDR+1
   LSR ENTRYDDR+1
   ROR

   ;** TIMES THREE
   STA ENTRYORK
   LDX ENTRYDDR+1
   ASL
   ROL ENTRYDDR+1
   CLC
   ADC ENTRYORK
   STA ENTRYDDR
   TXA
   ADC ENTRYDDR+1
   STA ENTRYDDR+1

   ;** ADD BASE, GET DATA
   CLC
   LDA ENTRYDDR
   ADC #<FATBUF
   STA ENTRYDDR
   LDA ENTRYDDR+1
   ADC #>FATBUF
   STA ENTRYDDR+1
   LDY #2
-  LDA (ENTRYDDR),Y
   STA ENTRYATA0,Y
   DEY
   BPL -
   RTS

GETATNTRY = *  ;( .=FATNTRYUMBER ) : .=FATNTRYALUE
   JSR LOCATEATNTRY
   LDA ENTRYITS
   AND #1
   BNE +

   ;** CASE 1: FIRST 12-BIT CLUSTER
   LDA ENTRYATA1
   AND #$0F
   TAY
   LDA ENTRYATA0
   RTS

   ;** CASE 2: SECOND 12-BIT CLUSTER
+  LDA ENTRYATA1
   LDX #4
-  LSR ENTRYATA2
   ROR
   DEX
   BNE -
   LDY ENTRYATA2
   RTS

FATALUE = 9

SETATNTRY = *  ;( .=FATNTRYUMBER, (FATALUE) )
   JSR LOCATEATNTRY
   LDA FATALUE+1
   AND #$0F
   STA FATALUE+1
   LDA ENTRYITS
   AND #1
   BNE +

   ;** CASE 1: FIRST 12-BIT CLUSTER
   LDA FATALUE
   STA ENTRYATA0
   LDA ENTRYATA1
   AND #$F0
   ORA FATALUE+1
   STA ENTRYATA1
   JMP SETATXIT

   ;** CASE 2: SECOND 12-BIT CLUSTER
+  LDX #4
-  ASL FATALUE
   ROL FATALUE+1
   DEX
   BNE -
   LDA FATALUE+1
   STA ENTRYATA2
   LDA ENTRYATA1
   AND #$0F
   ORA FATALUE
   STA ENTRYATA1

   SETATXIT = *
   LDY #2
-  LDA ENTRYATA0,Y
   STA (ENTRYDDR),Y
   DEY
   BPL -
   STY FATIRTY
   RTS

DIRTYIRENT = *  ;( WRITEIRENT )
   SEC
   LDA WRITEIRENT+0
   SBC #<DIRBUF
   LDA WRITEIRENT+1
   SBC #>DIRBUF
   LSR
   AND #$0F
   TAX
   LDA #$FF
   STA DIRIRTY,X
   RTS

DELLUSTER = 14

MSELETE = *  ;( WRITEIRENT )
   LDY #$0E
   STY $FF00
   LDA WRITEIRENT+0
   LDY WRITEIRENT+1
   STA 2
   STY 3
   LDA #$E5
   LDY #0
   STA (2),Y
   LDY #26
   LDA (2),Y
   STA DELLUSTER+0
   INY
   LDA (2),Y
   STA DELLUSTER+1
-  LDA DELLUSTER+1
   CMP #12  ;CLUSTER NUMBER HIGH BYTE
   BCC +
   JMP DIRTYIRENT
+  TAY
   LDA DELLUSTER
   JSR GETATNTRY
   PHA
   TYA
   PHA
   LDA #0
   STA FATALUE+0
   STA FATALUE+1
   LDA DELLUSTER+0
   LDY DELLUSTER+1
   JSR SETATNTRY
   PLA
   STA DELLUSTER+1
   PLA
   STA DELLUSTER
   JMP -

FLUSHLOCK = 14
FLUSHOUNTDOWN = $60
FLUSHEPEATS = $61
FLUSHIRNDEX = $61

MSLUSH = *  ;( MSEVICE, MSYPE ) : .=ERROR
   LDA #$0E
   STA $FF00
   LDA FATIRTY
   BEQ FLUSHIRECTORY
   LDA #0
   STA FATIRTY

   ;** FLUSH FAT
   LDA #2
   STA FLUSHEPEATS
   LDA #1
   STA FLUSHLOCK

   MASTERLUSH = *
   LDA FATLOCKS
   STA FLUSHOUNTDOWN
   LDA #<FATBUF
   LDY #>FATBUF
   STA BUFPTR
   STY BUFPTR+1
-  LDA FLUSHLOCK
   LDY #0
   JSR WRITEOGICALLOCK
   BCC +
   RTS
+  INC FLUSHLOCK
   DEC FLUSHOUNTDOWN
   BNE -
   DEC FLUSHEPEATS
   BNE MASTERLUSH

   ;** FLUSH DIRECTORY
   FLUSHIRECTORY = *
   LDA FIRSTOOTIRLOCK
   STA FLUSHLOCK
   LDA ROOTIRLOCKS
   STA FLUSHOUNTDOWN
   LDA #0
   STA FLUSHIRNDEX
   LDA #<DIRBUF
   LDY #>DIRBUF
   STA BUFPTR+0
   STY BUFPTR+1
-  LDX FLUSHIRNDEX
   LDA DIRIRTY,X
   BEQ +
   LDA #0
   STA DIRIRTY,X
   LDA FLUSHLOCK
   LDY #0
   JSR WRITEOGICALLOCK
   DEC BUFPTR+1
   DEC BUFPTR+1
+  INC FLUSHLOCK
   INC FLUSHIRNDEX
   INC BUFPTR+1
   INC BUFPTR+1
   DEC FLUSHOUNTDOWN
   BNE -
   CLC
   RTS

BFATNTRY = 14
BFLOCKS = $60

MSYTESREE = *  ;( ) : .=FILEYTESREE
   LDY #$0E
   STY $FF00
   LDA #2
   LDY #0
   STA BFATNTRY+0
   STY BFATNTRY+1
   STY BFLOCKS+0
   STY BFLOCKS+1
-  LDA BFATNTRY+0
   LDY BFATNTRY+1
   JSR GETATNTRY
   STY 2
   ORA 2
   BNE +
   INC BFLOCKS+0
   BNE +
   INC BFLOCKS+1
+  INC BFATNTRY
   BNE +
   INC BFATNTRY+1
+  LDA BFATNTRY+0
   CMP LASTATNTRY+0
   LDA BFATNTRY+1
   SBC LASTATNTRY+1
   BCC -
   LDX CLUSTERLOCKOUNT
-  ASL BFLOCKS
   ROL BFLOCKS+1
   DEX
   BNE -
   LDA #0
   LDY BFLOCKS+0
   LDX BFLOCKS+1
   RTS

;====FILE-COPY LEVEL====

TRANSODE = 14
LFN = 15
CBMATATR = $60
CBMATAEN = $62
CLUSTER = $64

COPYILELUSTER = *  ;( CLUSTER, LFN, TRANSODE ) : .=ERR
   LDA CLUSTER+0
   LDY CLUSTER+1
   JSR READLUSTER
   BCC +
   RTS
+  LDA #<CLUSTERUF
   LDY #>CLUSTERUF
   STA CBMATATR+0
   STY CBMATATR+1
   LDA #0
   STA CBMATAEN+0
   LDA CLUSTERLOCKOUNT
   ASL
   STA CBMATAEN+1

   ;**GET NEXT CLUSTER
   LDA CLUSTER+0
   LDY CLUSTER+1
   JSR GETATNTRY
   STA CLUSTER+0
   STY CLUSTER+1
   CPY #12  ;CLUSTER NUMBER HIGH BYTE
   BCC COPYILELUSTERATA
   LDA LEN
   STA CBMATAEN
   LDA #$01
   LDX CLUSTERLOCKOUNT
   CPX #1
   BEQ +
   LDA #$03
+  AND LEN+1
   BNE +
   LDX LEN
   BEQ COPYILELUSTERATA
+  STA CBMATAEN+1

   COPYILELUSTERATA = *
   JSR COMMIEUT
   RTS

CBMATAIMIT = $66

COMMIEUT = *  ;( CBMATATR, CBMATAEN ) : .=ERR
   LDX LFN
   BNE +
   CLC
   RTS
+  JSR KERNELHKOUT
   BCC COMMIEUTORE
   COMMIERROR = *
   CLC
   ADC #20
   SEC
   STA ERRNO
   RTS

   COMMIEUTORE = *
   LDA #255
   LDX CBMATAEN+1
   BNE +
   LDA CBMATAEN
+  STA CBMATAIMIT
   LDY #0
-  LDA (CBMATATR),Y
   BIT TRANSODE
   BPL +
   TAX
   LDA TRANSUF,X
   BEQ COMMIEEXT
+  JSR KERNELHROUT
   COMMIEEXT = *
   INY
   CPY CBMATAIMIT
   BNE -

   CLC
   LDA CBMATATR
   ADC CBMATAIMIT
   STA CBMATATR
   BCC +
   INC CBMATATR+1
+  SEC
   LDA CBMATAEN
   SBC CBMATAIMIT
   STA CBMATAEN
   BCS +
   DEC CBMATAEN+1
+  LDA CBMATAEN
   ORA CBMATAEN+1
   BNE COMMIEUTORE
   JSR KERNELLRCHN
   CLC
   RTS

TESTBORT = *
   JSR KERNELETIN
   BNE +
   CLC
   RTS
+  CMP #"A"
   BNE TESTBORT
   LDA #16  ;ABORT ERROR
   STA ERRNO
   SEC
   RTS

MSEAD = *  ;( CLUSTER, LEN, .=TRANSODE, .=LFN ) : .=ERR
   LDY #$0E
   STY $FF00
   STA TRANSODE
   STX LFN
   LDA STARTLUSTER+0
   LDY STARTLUSTER+1
   STA CLUSTER+0
   STY CLUSTER+1
   JMP +
-  JSR TESTBORT
   BCS ++
   JSR COPYILELUSTER
   BCC +
   RTS
+  LDA CLUSTER+1
   CMP #12  ;CLUSTER NUMBER HIGH BYTE
   BCC -
   CLC
+  RTS

INFN = $50
GENERATEF = $51
CBMATAAX = $52
REACHEDOF = $54
PREVT = $55

COMMIENNIT = *  ;( .=TRANSODE, .=INFN )
   STA TRANSODE
   STX INFN
   LDA #0
   STA GENERATEF
   STA REACHEDOF
   STA PREVT
   RTS

COMMIEN = *  ;( CBMATATR++, CBMATAAX ) : CBMATAEN, .=ERR, .=EOF
   LDA #0
   STA CBMATAEN
   STA CBMATAEN+1
   LDX REACHEDOF
   BEQ +
   LDA #0
   CLC
   RTS
+  LDX INFN
   JSR KERNELHKIN
   BCC COMMIENORE
   JMP COMMIERROR

   COMMIENORE = *
   LDA #255
   LDX CBMATAAX+1
   BNE +
   LDA CBMATAAX
+  STA CBMATAIMIT
   LDY #0
-  JSR COMMIENYTE
   BCC +
   RTS
+  BEQ +
   STA (CBMATATR),Y
   INY
   CPY CBMATAIMIT
   BNE -

+  STY CBMATAIMIT
   CLC
   LDA CBMATATR
   ADC CBMATAIMIT
   STA CBMATATR
   BCC +
   INC CBMATATR+1
+  CLC
   LDA CBMATAEN
   ADC CBMATAIMIT
   STA CBMATAEN
   BCC +
   INC CBMATAEN+1
+  SEC
   LDA CBMATAAX
   SBC CBMATAIMIT
   STA CBMATAAX
   BCS +
   DEC CBMATAAX+1
+  LDA REACHEDOF
   BNE +
   LDA CBMATAAX
   ORA CBMATAAX+1
   BNE COMMIENORE
+  JSR KERNELLRCHN
   LDA CBMATAEN
   ORA CBMATAEN+1
   CLC
   RTS

COMMIENYTE = *  ;( ) : .=CHAR, .=ERR, .=EOF, REACHEDOF
   ;** CHECK FOR ALREADY PAST EOF
   LDA REACHEDOF
   BEQ +
   BRK
   ;** CHECK FOR GENERATED LINEFEED
+  LDA GENERATEF
   BEQ +
   LDA #0
   STA GENERATEF
   LDA #$0A
   CLC
   RTS
   ;** CHECK FOR EOF
+  LDA PREVT
   AND #$40
   BEQ +
   LDA #$FF
   STA REACHEDOF
   LDA #0
   CLC
   RTS
   ;** READ ACTUAL CHARACTER
+  JSR KERNELHRIN
   LDX ST
   STX PREVT
   BCC +
   PHA
   JSR KERNELLRCHN
   PLA
   JMP COMMIERROR
   ;** TRANSLATE IF NECESSARY
+  BIT TRANSODE
   BPL +
   TAX
   LDA TRANSUFOSCII,X
   BEQ COMMIENYTE
   CMP #$0D
   BNE +
   STA GENERATEF
   ;** EXIT
+  LDX #$FF
   CLC
   RTS

FIRSTREEATNTRY = $5A

ALLOCATEATNTRY = *  ;( ) : .=FATNTRY, .=ERR
-  LDA FIRSTREEATNTRY
   CMP LASTATNTRY
   LDA FIRSTREEATNTRY+1
   SBC LASTATNTRY+1
   BCC +
   LDA #19 ;DISK FULL ERR
   STA ERRNO
   RTS
+  LDA FIRSTREEATNTRY
   LDY FIRSTREEATNTRY+1
   JSR GETATNTRY
   STY 2
   ORA 2
   BNE +
   LDA FIRSTREEATNTRY
   LDY FIRSTREEATNTRY+1
   CLC
   RTS
+  INC FIRSTREEATNTRY
   BNE -
   INC FIRSTREEATNTRY+1
   JMP -

MSILEENGTH = $5C  ;(3 BYTES)

MSRITELUSTER = *  ; (*) : .=ERR
   ;** GET A NEW CLUSTER
   JSR ALLOCATEATNTRY
   BCC +
   RTS
   ;** MAKE PREVIOUS FAT ENTRY POINT TO NEW CLUSTER
+  STA FATALUE
   STY FATALUE+1
   LDA CLUSTER
   ORA CLUSTER+1
   BEQ +
   LDA CLUSTER
   LDY CLUSTER+1
   LDX FATALUE
   STX CLUSTER
   LDX FATALUE+1
   STX CLUSTER+1
   JSR SETATNTRY
   JMP MSLUSTEREW
+  LDA WRITEIRENT
   LDY WRITEIRENT+1
   STA 2
   STY 3
   LDY #26
   LDA FATALUE
   STA (2),Y
   STA CLUSTER
   INY
   LDA FATALUE+1
   STA (2),Y
   STA CLUSTER+1

   ;** MAKE NEW FAT ENTRY POINT TO NULL
   MSLUSTEREW = *
   LDA #$FF
   LDY #$0F
   STA FATALUE
   STY FATALUE+1
   LDA CLUSTER
   LDY CLUSTER+1
   JSR SETATNTRY
   ;** WRITE NEW CLUSTER DATA
+  LDA CLUSTER
   LDY CLUSTER+1
   JSR WRITELUSTER
   BCC +
   RTS
   ;** ADD CLUSTER LENGTH TO FILE LENGTH
+  CLC
   LDA MSILEENGTH
   ADC CBMATAEN
   STA MSILEENGTH
   LDA MSILEENGTH+1
   ADC CBMATAEN+1
   STA MSILEENGTH+1
   BCC +
   INC MSILEENGTH+2
+  CLC
   RTS

MSRITE = *  ;( MSEVICE, MSYPE, WRITEIRENT, .=TRANS, .=CBMFN ) :.=ERR
   LDY #$0E
   STY $FF00
   ;** INITIALIZE
   JSR COMMIENNIT
   LDA #0
   STA CLUSTER
   STA CLUSTER+1
   STA FIRSTREEATNTRY+1
   STA MSILEENGTH
   STA MSILEENGTH+1
   STA MSILEENGTH+2
   LDA #2
   STA FIRSTREEATNTRY

   ;** COPY CLUSTER FROM CBM FILE
-  JSR TESTBORT
   BCC +
   RTS
+  LDA #<CLUSTERUF
   LDY #>CLUSTERUF
   STA CBMATATR
   STY CBMATATR+1
   LDA CLUSTERLOCKOUNT
   ASL
   TAY
   LDA #0
   STA CBMATAAX
   STY CBMATAAX+1
   JSR COMMIEN
   BCC +
   RTS
+  BEQ +
   JSR MSRITELUSTER
   BCC -
   RTS

   ;** WRAP UP AFTER WRITING - SET FILE LENGTH, DIRTY FLAG, EXIT.
+  LDA WRITEIRENT
   LDY WRITEIRENT+1
   STA 2
   STY 3
   LDX #0
   LDY #28
-  LDA MSILEENGTH,X
   STA (2),Y
   INY
   INX
   CPX #3
   BCC -
   JSR DIRTYIRENT
   CLC
   RTS

;===== COMMODORE FILE LEVEL =====

CBMOPYRANS .BUF 1

CBMOPY = *  ;( .=INFN, .=OUTFN, .=OUTSCOBMRANSLATIONLAG )
   STY CBMOPYRANS
   LDY #$0E
   STY $FF00
   STX LFN
   TAX
   LDA #0
   JSR COMMIENNIT
-  JSR TESTBORT
   BCS +
   LDA #<CLUSTERUF
   LDY #>CLUSTERUF
   STA CBMATATR+0
   STY CBMATATR+1
   LDA #<1024
   LDY #>1024
   STA CBMATAAX+0
   STY CBMATAAX+1
   JSR COMMIEN
   BCS +
   BEQ +
   LDA #<CLUSTERUF
   LDY #>CLUSTERUF
   STA CBMATATR+0
   STY CBMATATR+1
   LDA CBMOPYRANS
   STA TRANSODE
   JSR COMMIEUT
   LDA #0
   STA TRANSODE
   BCS +
   JMP -
+  RTS

CBMIRENT = *  ;( .=LFN )
   LDY #$0E
   STY $FF00
   TAX
   JSR KERNELHKIN
   BCC ++
   CDIRRR = *
+  LDA #0
   STA CDIRLEN
   STA CDIRLOCKS
   STA CDIRLOCKS+1
   RTS
   ;** GET BLOCK COUNT
+  JSR CDIRETCH
   JSR CDIRETCH
   JSR CDIRETCH
   STA CDIRLOCKS
   JSR CDIRETCH
   STA CDIRLOCKS+1
   ;** LOOK FOR FILENAME
   LDA #0
   STA CDIRLEN
-  JSR CDIRETCH
   CMP #34
   BEQ +
   CMP #"B"
   BNE -
   JSR KERNELLRCHN
   RTS
   ;** GET FILENAME
+  LDY #0
-  JSR CDIRETCH
   CMP #34
   BEQ +
   STA CDIRAME,Y
   INY
   BNE -
+  STY CDIRLEN
-  JSR CDIRETCH
   CMP #" "
   BEQ -
   STA CDIRYPE
-  JSR CDIRETCH
   CMP #0
   BNE -
   JSR KERNELLRCHN
   RTS

CDIRETCH = *
   JSR KERNELHRIN
   BCS +
   BIT ST
   BVS +
   RTS
+  PLA
   PLA
   JSR KERNELLRCHN
   JMP CDIRRR

;===== DATA =====

TRANSUF = *
       ;0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$14,$09,$0D,$00,$93,$00,$00,$00 ;0
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;1
.BYTE $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F ;2
.BYTE $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F ;3
.BYTE $40,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF ;4
.BYTE $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$5B,$5C,$5D,$5E,$5F ;5
.BYTE $C0,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F ;6
.BYTE $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$DB,$DC,$DD,$DE,$DF ;7
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;8
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;9
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;A
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;B
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;C
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;D
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;E
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;F

TRANSUFOSCII = *
       ;0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$09,$00,$00,$00,$0D,$00,$00 ;0
.BYTE $00,$00,$00,$00,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;1
.BYTE $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F ;2
.BYTE $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F ;3
.BYTE $40,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F ;4
.BYTE $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$5B,$5C,$5D,$5E,$5F ;5
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;6
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;7
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;8
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;9
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;A
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;B
.BYTE $60,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F ;C
.BYTE $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$7B,$7C,$7D,$7E,$7F ;D
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;E
.BYTE $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7E ;F

;====BSS STORAGE (SIZE=22,016 BYTES)====

BSS = *
TRACKBUF   = BSS+0     ;(9216)  ;ROOM FOR 18 X 512-BYTE SECTORS
CLUSTERUF = BSS+9216  ;(1024)  ;2 SECTORS
FATBUF     = BSS+10240 ;(4608)  ;9 SECTORS
DIRBUF     = BSS+14848 ;(7168)  ;14 SECTORS = 224 DIRENTS
BSSND     = BSS+22016

